//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
#include "TDx_Draw.h"
#include "TDx_DrawSurface.h"
#include "TDDCaps.h"
#include "TDDPixelFormat.h"
#include "TDDSCaps.h"
#include "TDDSurfaceDesc.h"
//---------------------------------------------------------------------------

#if (__BORLANDC__ < 0x0530) // BCB Version 1
class TMainForm : public TForm
{
#else // BCB Version 3 +
class PACKAGE TMainForm : public TForm
{
#endif

//---------------------------------------------------------------------------
// Anything that is to be displayed within the Object Inspector
//---------------------------------------------------------------------------
__published:

    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label5;

    TMemo *InfoMemo;
    TMemo *StatusMemo;

    TListBox *DevicesListBox;

    TBitBtn *EnumerateButton;
    TBitBtn *CreateDefaultButton;
    TBitBtn *CreateSelectedButton;
    TBitBtn *DestroyActiveButton;
    TBitBtn *RetrieveCapsButton;
    TBitBtn *SetCoopButton;
    TBitBtn *RestoreCoopButton;
    TBitBtn *ExitButton;
    TBitBtn *ClearMessagesButton;

    TListBox *HelCapsListBox;
    TListBox *DriverCapsListBox;

    TDDCaps *HelCaps;
    TDDCaps *DriverCaps;
    TDx_Draw *Dx_Draw1;

    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall EnumerateButtonClick(TObject *Sender);
    void __fastcall CreateDefaultButtonClick(TObject *Sender);
    void __fastcall CreateSelectedButtonClick(TObject *Sender);
    void __fastcall DestroyActiveButtonClick(TObject *Sender);
    void __fastcall RetrieveCapsButtonClick(TObject *Sender);
    void __fastcall SetCoopButtonClick(TObject *Sender);
    void __fastcall RestoreCoopButtonClick(TObject *Sender);
    void __fastcall ExitButtonClick(TObject *Sender);
    void __fastcall ClearMessagesButtonClick(TObject *Sender);

    void __fastcall DevicesListBoxClick(TObject *Sender);

    void __fastcall Dx_Draw1Create(TObject *Sender);
    void __fastcall Dx_Draw1Destroy(TObject *Sender);
    void __fastcall Dx_Draw1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage);

    void __fastcall Dx_Draw1DDEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverName, void *Context,
    HMONITOR HMonitor, bool &Finished);

//---------------------------------------------------------------------------
// Anything available to other classes and/or code
//---------------------------------------------------------------------------
public:

    __fastcall TMainForm(TComponent* Owner);
    virtual __fastcall ~TMainForm();

//---------------------------------------------------------------------------
// Anything available only to classes descended from this class
//---------------------------------------------------------------------------
protected:

//---------------------------------------------------------------------------
// Private data not accessible except from within this class
//---------------------------------------------------------------------------
private:

    #define MAX_DEVICES 5
    #define MAX_MODES   50

    AnsiString  Names[MAX_DEVICES];
    AnsiString  Descriptions[MAX_DEVICES];
    GUID*       Guids[MAX_DEVICES];
    int         NumDevices;

    int         Widths[MAX_MODES];
    int         Heights[MAX_MODES];
    int         BitDepths[MAX_MODES];
    int         RefreshRates[MAX_MODES];
    int         NumModes;

};
//---------------------------------------------------------------------------
#if (__BORLANDC__ < 0x0530) // BCB Version 1
extern TMainForm *MainForm;
#else // BCB Version 3 +
extern PACKAGE TMainForm *MainForm;
#endif
//---------------------------------------------------------------------------
#endif

