//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
#include "TDx_Draw.h"
#include "TDx_DrawSurface.h"
#include "TDDCaps.h"
#include "TDDPixelFormat.h"
#include "TDDSCaps.h"
#include "TDDSurfaceDesc.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;

    TMemo *InfoMemo;
    TMemo *StatusMemo;

    TListBox *DevicesListBox;
    TListBox *ModesListBox;

    TBitBtn *EnumerateButton;
    TBitBtn *CreateDefaultButton;
    TBitBtn *CreateSelectedButton;
    TBitBtn *DestroyActiveButton;
    TBitBtn *EnumerateModesButton;
    TBitBtn *Enumerate800ModesButton;
    TBitBtn *SetModeButton;
    TBitBtn *RestoreModeButton;
    TBitBtn *ClearButton;
    TBitBtn *ExitButton;

    TDx_Draw *Dx_Draw1;
    TDDCaps *DriverCaps;
    TDDCaps *HelCaps;
    TDDSurfaceDesc *DDSurfaceDesc1;
    TDDPixelFormat *DDPixelFormat1;

    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);

    void __fastcall EnumerateButtonClick(TObject *Sender);
    void __fastcall CreateDefaultButtonClick(TObject *Sender);
    void __fastcall CreateSelectedButtonClick(TObject *Sender);
    void __fastcall DestroyActiveButtonClick(TObject *Sender);
    void __fastcall EnumerateModesButtonClick(TObject *Sender);
    void __fastcall Enumerate800ModesButtonClick(TObject *Sender);
    void __fastcall SetModeButtonClick(TObject *Sender);
    void __fastcall RestoreModeButtonClick(TObject *Sender);
    void __fastcall ClearButtonClick(TObject *Sender);
    void __fastcall ExitButtonClick(TObject *Sender);

    void __fastcall ModesListBoxClick(TObject *Sender);
    void __fastcall DevicesListBoxClick(TObject *Sender);

    void __fastcall Dx_Draw1Create(TObject *Sender);
    void __fastcall Dx_Draw1Destroy(TObject *Sender);
    void __fastcall Dx_Draw1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage);

    void __fastcall Dx_Draw1EnumDisplayModes(TObject *Sender,
    TDDSurfaceDesc *SurfaceDesc, void *Context, bool &Finished);

    void __fastcall Dx_Draw1DDEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverName, void *Context,
    HMONITOR HMonitor, bool &Finished);

private:	// User declarations

    #define MAX_DEVICES 5
    #define MAX_MODES   50

    AnsiString  Names[MAX_DEVICES];
    AnsiString  Descriptions[MAX_DEVICES];
    GUID*       Guids[MAX_DEVICES];
    int         NumDevices;

    int         Widths[MAX_MODES];
    int         Heights[MAX_MODES];
    int         BitDepths[MAX_MODES];
    int         RefreshRates[MAX_MODES];
    int         NumModes;

public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
