//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include "TMainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
#pragma link "TDx_Draw_Library_Install"
#pragma link "TDx_Draw"
#pragma link "TDx_DrawSurface"
#pragma link "TDDCaps"
#pragma link "TDDSCaps"
#pragma link "TDDSurfaceDesc"
//---------------------------------------------------------------------------
TMainForm *MainForm;
//---------------------------------------------------------------------------
#define Msg(A)  {\
                if (StatusMemo->Text.Length()>30000) StatusMemo->Text = "";\
                StatusMemo->Lines->Add(A);\
                }
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
FlipCount=0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
Width=780;
Height=580;
Position=poScreenCenter;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
if (Dx_Draw1->Created) Dx_Draw1->Destroy();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
Msg("Scanning for Available Devices");
NumDevices = 0;
Dx_Draw1->DDEnumerate(NULL,0);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateButtonClick(TObject *Sender)
{
Msg("Creating Selected Device");
if (Dx_Draw1->Created)
    Dx_Draw1->Destroy();

int index = DevicesListBox->ItemIndex;
Dx_Draw1->Create( Guids[index] );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetModeButtonClick(TObject *Sender)
{
if (ModesListBox->Items->Count>0)
    {
    ShowMessage("Please Note:\n\
You may experience difficulty restoring your display mode.\n\
To return to the original display mode at any time, press ALT-R (Restore) or ALT-X (eXit)" );

    RestoreModeButton->Enabled = true;

    int index = ModesListBox->ItemIndex;
    Dx_Draw1->SetDisplayMode( Widths[index], Heights[index], BitDepths[index], RefreshRates[index], 0 );

    Top=0;
    Left=0;

    RestoreModeButton->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RestoreModeButtonClick(TObject *Sender)
{
Msg("Restoring Display Mode");
Dx_Draw1->RestoreDisplayMode();

// repaint the form, using a trick
int old = Top;
Top=Screen->Height+1;
Top=old;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DestroyButtonClick(TObject *Sender)
{
Msg("Destroying Active Device");

if (Dx_Draw1->Created)
    {
    Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_NORMAL );
    Dx_Draw1->Destroy();
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreatePrimaryButtonClick(TObject *Sender)
{
if (PrimarySurface->Created) PrimarySurface->Destroy();
PrimarySurface->Create( PrimarySurfaceDesc, Dx_Draw1 );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RetrieveCapsButtonClick(TObject *Sender)
{
CapsListBox->Items->Clear();
if (PrimarySurface->GetCaps( PrimarySurfaceCaps ))
    {
    CapsListBox->Items->Add( "Caps:" );
    CapsListBox->Items->AddStrings( PrimarySurfaceCaps->Caps_Strings );
    CapsListBox->Items->Add( "Caps2:" );
    CapsListBox->Items->AddStrings( PrimarySurfaceCaps->Caps2_Strings );
    }
else
    CapsListBox->Items->Add( "---- Unknown ----" );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RetrieveDescButtonClick(TObject *Sender)
{
DescListBox->Items->Clear();
if (PrimarySurface->GetSurfaceDesc( PrimarySurfaceDesc ))
    {
    TDDSurfaceDesc* sd = PrimarySurfaceDesc;
    AnsiString null_string = "NULL";

    DescListBox->Items->Add("AlphaBitDepth="+IntToStr(sd->AlphaBitDepth));
    DescListBox->Items->Add("BackBufferCount="+IntToStr(sd->BackBufferCount));
    DescListBox->Items->Add("CKDestBlt='"+AnsiString((sd->CKDestBlt==NULL) ? null_string : sd->CKDestBlt->Name)+"'");
    DescListBox->Items->Add("CKDestOverlay='"+AnsiString((sd->CKDestOverlay==NULL) ? null_string : sd->CKDestOverlay->Name)+"'");
    DescListBox->Items->Add("CKSrcBlt='"+AnsiString((sd->CKSrcBlt==NULL) ? null_string : sd->CKSrcBlt->Name)+"'");
    DescListBox->Items->Add("CKSrcOverlay='"+AnsiString((sd->CKSrcOverlay==NULL) ? null_string : sd->CKSrcOverlay->Name)+"'");
    DescListBox->Items->Add("EmptyFaceColor="+IntToStr(sd->EmptyFaceColor));
    DescListBox->Items->Add("Flags=");
    DescListBox->Items->AddStrings(sd->Flags_Strings);
    DescListBox->Items->Add("Height="+IntToStr(sd->Height));
    DescListBox->Items->Add("LinearSize="+IntToStr(sd->LinearSize));
    DescListBox->Items->Add("MipMapCount="+IntToStr(sd->MipMapCount));
    DescListBox->Items->Add("Pitch="+IntToStr((int)sd->Pitch));
    DescListBox->Items->Add("PixelFormat='"+AnsiString((sd->PixelFormat==NULL) ? null_string : sd->PixelFormat->Name)+"'");
    DescListBox->Items->Add("RefreshRate="+IntToStr(sd->RefreshRate));
    DescListBox->Items->Add("Height="+IntToStr(sd->Height));
    DescListBox->Items->Add("SCaps='"+AnsiString((sd->SCaps==NULL) ? null_string : sd->SCaps->Name)+"'");
    DescListBox->Items->Add("Surface='"+AnsiString((sd->Surface==NULL) ? null_string : sd->Surface->Name)+"'");
    DescListBox->Items->Add("TextureStage="+IntToStr(sd->TextureStage));
    DescListBox->Items->Add("Width="+IntToStr(sd->Width));
    }
else
    DescListBox->Items->Add( "---- Unknown ----" );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PaintWin32ButtonClick(TObject *Sender)
{
// BEWARE:
//
// Always make sure your code calls ReleaseDC() whenever GetDC() works.
//
// if you do not call ReleaseDC() correctly, your display may "hang"
// fatally because the primary surface is still locked and windows cannot
// update the display. if this happens your machine will require a reboot.
//
// similarly, if you do not trap Exceptions that occur between a
// GetDC() / ReleaseDC() call, and win32 or the BCB debugger jumps in,
// you may also "hang" your display, and again require a reboot.

// non-error-proof win32 code
HDC hdc;
if (PrimarySurface->GetDC(&hdc))
    {
    LPSTR szMessage = "This is the Primary Surface";
    for (int i=0;i<255;i++)
        {
        SetBkColor( hdc, RGB(255-i,255-i,255) );
        SetTextColor( hdc, RGB(i,255-i,0) );
        TextOut( hdc, i, i, szMessage, lstrlen(szMessage) );
        }
    PrimarySurface->ReleaseDC(hdc);
    }

// error-proof win32 code
if (PrimarySurface->GetDC(&hdc))
    {
    try
        {
        LPSTR szMessage = "This is the Primary Surface";
        for (int i=0;i<255;i++)
            {
            SetBkColor( hdc, RGB(255-i,255-i,255) );
            SetTextColor( hdc, RGB(i,255-i,0) );
            TextOut( hdc, i, 255-i, szMessage, lstrlen(szMessage) );
            }
        }
    catch (Exception &e)
        {
        }
    PrimarySurface->ReleaseDC(hdc);
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PaintVCLButtonClick(TObject *Sender)
{
TCanvas* canvas = new TCanvas();
if (canvas==NULL)
    {
    ShowMessage("Could not create VCL canvas");
    return;
    }

// non-error-proof vcl code
HDC hdc;
if (PrimarySurface->GetDC(&hdc))
    {
    canvas->Handle = hdc;

    // the following 2 lines approximate the font used in win32 code above.
    canvas->Font->Height = 16;
    canvas->Font->Style = TFontStyles() << fsBold;

    AnsiString message = "This is the Primary Surface";
    for (int i=0;i<255;i++)
        {
        canvas->Brush->Color = (TColor) RGB(255-i,255-i,255);
        canvas->Font->Color = (TColor) RGB(i,255-i,0);
        canvas->TextOut( i, i, message );
        }

    PrimarySurface->ReleaseDC(hdc);
    }

// error-proof vcl code
if (PrimarySurface->GetDC(&hdc))
    {
    try
        {
        canvas->Handle = hdc;

        // the following 2 lines approximate the font used in win32 code above.
        canvas->Font->Height = 16;
        canvas->Font->Style = TFontStyles() << fsBold;

        AnsiString message = "This is the Primary Surface";
        for (int i=0;i<255;i++)
            {
            canvas->Brush->Color = (TColor) RGB(255-i,255-i,255);
            canvas->Font->Color = (TColor) RGB(i,255-i,0);
            canvas->TextOut( i, 255-i, message );
            }
        }
    catch (Exception &e)
        {
        }

    PrimarySurface->ReleaseDC(hdc);
    }

delete canvas;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DestroySurfaceButtonClick(TObject *Sender)
{
if (PrimarySurface->Created) PrimarySurface->Destroy();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClearButtonClick(TObject *Sender)
{
StatusMemo->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExitButtonClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxClick(TObject *Sender)
{
if (DevicesListBox->Items->Count>0)
    {
    int index = DevicesListBox->ItemIndex;
    AnsiString device_name = DevicesListBox->Items->Strings[index];
    Msg("Device Selected: '"+device_name+"'");
    CreateButton->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ModesListBoxClick(TObject *Sender)
{
if (ModesListBox->Items->Count>0)
    {
    Msg("Mode Selected");
    SetModeButton->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Create(TObject *Sender)
{
Msg("Device has been created");

Msg("Setting Fullscreen/Exclusive Mode");
Dx_Draw1->SetCooperativeLevel( Application->Handle, DDSCL_FULLSCREEN | DDSCL_EXCLUSIVE );

Msg("Enumerating Display Modes");
ModesListBox->Items->Clear();
NumModes = 0;
Dx_Draw1->EnumDisplayModes(0,NULL,NULL);

CreateButton->Enabled = false;
DestroyButton->Enabled = true;
CreatePrimaryButton->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Destroy(TObject *Sender)
{
Msg("Device is being Destroyed");
if (PrimarySurface->Created) PrimarySurface->Destroy();

CreateButton->Enabled = true;
DestroyButton->Enabled = false;
CreatePrimaryButton->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage)
{
Msg("ERROR ["+Error+"]: "+Function+", "+ErrorMessage);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1DDEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverName, void *Context,
    HMONITOR HMonitor, bool &Finished)
{
if (NumDevices<5)
    {
    Guids[NumDevices] = Guid;
    Names[NumDevices] = DriverName;
    Descriptions[NumDevices] = DriverDescription;
    NumDevices++;

    Msg("Found a device: "+DriverName+", "+DriverDescription);
    DevicesListBox->Items->Add( DriverName+", "+DriverDescription );
    }
else
    Finished = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Draw1EnumDisplayModes(TObject *Sender,
    TDDSurfaceDesc *SurfaceDesc, void *Context, bool &Finished)
{
int width = SurfaceDesc->Width;
int height = SurfaceDesc->Height;
int refresh_rate = SurfaceDesc->RefreshRate;
int bit_depth;

if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED1) bit_depth = 1;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED2) bit_depth = 2;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED4) bit_depth = 4;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXED8) bit_depth = 8;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_PALETTEINDEXEDTO8) bit_depth = 8;
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_ALPHA) bit_depth = SurfaceDesc->PixelFormat->AlphaBitDepth[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_ALPHAPIXELS) bit_depth = SurfaceDesc->PixelFormat->AlphaBitDepth[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_ALPHAPREMULT) bit_depth = SurfaceDesc->PixelFormat->AlphaBitDepth[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_BUMPDUDV) bit_depth = SurfaceDesc->PixelFormat->BumpBitCount[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_BUMPLUMINANCE) bit_depth = SurfaceDesc->PixelFormat->BumpBitCount[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_RGB) bit_depth = SurfaceDesc->PixelFormat->RGBBitCount[0];
else if (SurfaceDesc->PixelFormat->Flags[0] & DDPF_YUV) bit_depth = SurfaceDesc->PixelFormat->YUVBitCount[0];

if (NumModes<50)
    {
    Widths[NumModes] = width;
    Heights[NumModes] = height;
    BitDepths[NumModes] = bit_depth;
    RefreshRates[NumModes] = refresh_rate;
    NumModes++;
    ModesListBox->Items->Add( IntToStr(width)+"x"+IntToStr(height)+"x"+IntToStr(bit_depth)+" @ "+IntToStr(refresh_rate)+"Hz" );
    }
else
    Finished = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PrimarySurfaceCreate(TObject *Sender)
{
Msg("Primary Surface has been Created");

DestroySurfaceButton->Enabled = true;
RetrieveCapsButton->Enabled = true;
RetrieveDescButton->Enabled = true;
PaintWin32Button->Enabled = true;
PaintVCLButton->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PrimarySurfaceDestroy(TObject *Sender)
{
Msg("Primary Surface is being Destroyed");

DestroySurfaceButton->Enabled = false;
RetrieveCapsButton->Enabled = false;
RetrieveDescButton->Enabled = false;
PaintWin32Button->Enabled = false;
PaintVCLButton->Enabled = false;
}
//---------------------------------------------------------------------------
