//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
#include "TDx_Draw.h"
#include "TDx_DrawSurface.h"
#include "TDDCaps.h"
#include "TDDSCaps.h"
#include "TDDSurfaceDesc.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;

    TTimer *Timer1;

    TMemo *InfoMemo;
    TMemo *StatusMemo;

    TListBox *ModesListBox;
    TListBox *DevicesListBox;

    TBitBtn *CreateButton;
    TBitBtn *SetModeButton;
    TBitBtn *RestoreModeButton;
    TBitBtn *DestroyButton;
    TBitBtn *CreateBackButton;
    TBitBtn *FlipButton;
    TBitBtn *DestroySurfacesButton;
    TBitBtn *ClearButton;
    TBitBtn *ExitButton;

    TDx_Draw *Dx_Draw1;
    TDx_DrawSurface *BackBuffer;
    TDx_DrawSurface *PrimarySurface;
    TDDSCaps *BackBufferCaps;
    TDDSCaps *PrimarySurfaceCaps;
    TDDSurfaceDesc *BackBufferDesc;
    TDDSurfaceDesc *PrimarySurfaceDesc;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);

    void __fastcall CreateButtonClick(TObject *Sender);
    void __fastcall SetModeButtonClick(TObject *Sender);
    void __fastcall RestoreModeButtonClick(TObject *Sender);
    void __fastcall DestroyButtonClick(TObject *Sender);
    void __fastcall CreateBackButtonClick(TObject *Sender);
    void __fastcall FlipButtonClick(TObject *Sender);
    void __fastcall DestroySurfacesButtonClick(TObject *Sender);
    void __fastcall ClearButtonClick(TObject *Sender);
    void __fastcall ExitButtonClick(TObject *Sender);
    
    void __fastcall ModesListBoxClick(TObject *Sender);
    void __fastcall DevicesListBoxClick(TObject *Sender);

    void __fastcall Dx_Draw1Create(TObject *Sender);
    void __fastcall Dx_Draw1Destroy(TObject *Sender);
    void __fastcall Dx_Draw1Error(TObject *Sender, AnsiString Function,
    AnsiString Error, AnsiString ErrorMessage);

    void __fastcall Dx_Draw1DDEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverName, void *Context,
    HMONITOR HMonitor, bool &Finished);

    void __fastcall Dx_Draw1EnumDisplayModes(TObject *Sender,
    TDDSurfaceDesc *SurfaceDesc, void *Context, bool &Finished);

    void __fastcall BackBufferCreate(TObject *Sender);
    void __fastcall PrimarySurfaceCreate(TObject *Sender);
    void __fastcall PrimarySurfaceDestroy(TObject *Sender);
    void __fastcall BackBufferDestroy(TObject *Sender);

    // this is the main animation loop as such
    void __fastcall Timer1Timer(TObject *Sender);

private:	// User declarations

    AnsiString  Names[5];
    AnsiString  Descriptions[5];
    GUID*       Guids[5];
    int         NumDevices;

    int         Widths[50];
    int         Heights[50];
    int         BitDepths[50];
    int         RefreshRates[50];
    int         NumModes;

    int         FlipCount;

public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
